"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const shared_utils_1 = require("../../utils/shared.utils");
const constants_1 = require("../../constants");
/**
 * Defines the Controller. The controller can inject dependencies through constructor.
 * Those dependencies have to belong to the same module.
 */
function Controller(prefix) {
    const path = shared_utils_1.isUndefined(prefix) ? '/' : prefix;
    return (target) => {
        Reflect.defineMetadata(constants_1.PATH_METADATA, path, target);
    };
}
exports.Controller = Controller;
