import { CustomTransportStrategy } from '../interfaces';
import { MicroserviceOptions } from '../interfaces/microservice-configuration.interface';
import { Server } from './server';
export declare class ServerRMQ extends Server implements CustomTransportStrategy {
    private readonly options;
    private server;
    private channel;
    private readonly urls;
    private readonly queue;
    private readonly prefetchCount;
    private readonly queueOptions;
    private readonly isGlobalPrefetchCount;
    constructor(options: MicroserviceOptions);
    listen(callback: () => void): Promise<void>;
    close(): void;
    start(callback?: () => void): Promise<void>;
    createClient<T = any>(): T;
    setupChannel(channel: any, callback: Function): Promise<void>;
    handleMessage(message: any): Promise<void>;
    sendMessage<T = any>(message: T, replyTo: any, correlationId: string): void;
}
